--- chan_phone.c.orig	2005-07-16 03:00:46.000000000 +0400
+++ chan_phone.c	2005-08-23 11:01:20.000000000 +0400
@@ -146,6 +146,7 @@
 static struct ast_frame *phone_exception(struct ast_channel *ast);
 static int phone_send_text(struct ast_channel *ast, const char *text);
 static int phone_fixup(struct ast_channel *old, struct ast_channel *new);
+static int phone_indicate(struct ast_channel *chan, int condition);
 
 static const struct ast_channel_tech phone_tech = {
 	.type = type,
@@ -159,6 +160,7 @@
 	.read = phone_read,
 	.write = phone_write,
 	.exception = phone_exception,
+	.indicate = phone_indicate,
 	.fixup = phone_fixup
 };
 
@@ -175,11 +177,31 @@
 	.exception = phone_exception,
 	.write_video = phone_write,
 	.send_text = phone_send_text,
+	.indicate = phone_indicate,
 	.fixup = phone_fixup
 };
 
 static struct ast_channel_tech *cur_tech;
 
+static int phone_indicate(struct ast_channel *chan, int condition)
+{
+	struct phone_pvt *p = chan->tech_pvt;
+	int res=-1;
+	ast_log(LOG_DEBUG, "Requested indication %d on channel %s\n", condition, chan->name);
+	switch(condition) {
+		case AST_CONTROL_FLASH:
+			ioctl(p->fd, IXJCTL_PSTN_SET_STATE, PSTN_ON_HOOK);
+			usleep(320000);
+			ioctl(p->fd, IXJCTL_PSTN_SET_STATE, PSTN_OFF_HOOK);
+			p->lastformat = -1;
+			res = 0;
+			break;
+		default:
+			ast_log(LOG_WARNING, "Condition %d is not supported on channel %s\n", condition, chan->name);
+	}
+	return res;
+}
+
 static int phone_fixup(struct ast_channel *old, struct ast_channel *new)
 {
 	struct phone_pvt *pvt = old->tech_pvt;
